#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Syncfusion.GridExcelConverter;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;

namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(440, 208);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Import Excel";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.ColCount = 13;
			this.gridControl1.Location = new System.Drawing.Point(8, 8);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 9;
			this.gridControl1.Size = new System.Drawing.Size(1000, 184);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 1;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.ThemesEnabled = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1016, 246);
			this.Controls.Add(this.gridControl1);
			this.Controls.Add(this.button1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Essential XlsIO Sample";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{

			this.Cursor = Cursors.WaitCursor;

			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//Open an existing spreadsheet which will be used as a template for generating the new spreadsheet.
			//After opening, the workbook object represents the complete in-memory object model of the template spreadsheet.
			IWorkbook workbook = excelEngine.Excel.Workbooks.Open("Sample.xls"); 
			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];

			//Imports excel to grid using GridExcelConverter control.
			GridExcelConverterControl grid=new GridExcelConverterControl ();
			this.gridControl1.BeginUpdate();
			grid.ExcelToGrid(sheet,this.gridControl1.Model);

			for(int i=1;i<=sheet.UsedRange.End.Row;i++)
				for(int j=1;j<=sheet.UsedRange.End.Column;j++)
				{
					GridStyleInfo style= this.gridControl1[i,j] ;
					style.Font.Bold =sheet.Range [i,j].CellStyle.Font.Bold;
					style.Font.Italic =sheet.Range [i,j].CellStyle.Font.Italic;
					style.TextColor =sheet.Range [i,j].CellStyle.Font.RGBColor;
					style.Font.Underline = (sheet.Range [i,j].CellStyle.Font.Underline != ExcelUnderline.None);
					if(sheet.Range [i,j].CellStyle.FillBackgroundRGB!=Color.Black)
						style.BackColor =sheet.Range [i,j].CellStyle.FillBackgroundRGB;
				
				}
			
			this.gridControl1.EndUpdate();
			//Saving the workbook to disk.
			workbook.SaveAs("SavedSample.xls");

			workbook.Saved=true;

			//Close the workbook.
			workbook.Close();

			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose();
			this.Cursor = Cursors.Default;
									
		}
				
	}
}
